=== src/downloader/lib/src/lib/sha1/CMakeLists.txt ===
add_library(pr-sha1 STATIC
	sha1.cpp
)
