=== debian/changelog ===
springlobby (0.269-1build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sun, 02 Feb 2020 20:30:48 +0100

springlobby (0.269-1) unstable; urgency=medium

  * New upstream version 0.269.
  * Drop regen_config_header.sh.patch. Fixed upstream.

 -- Markus Koschany <apo@debian.org>  Thu, 19 Dec 2019 22:49:17 +0100
