=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
# Disable wxwidgets3.0 assertions
export DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

PROGDIR := $(CURDIR)/debian/springlobby

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	cp src/downloader/lib/cmake/FindJsoncpp.cmake cmake/
	dh_auto_configure --  \
		-DPRD_JSONCPP_INTERNAL=OFF \
		-DLSL_JSONCPP_INTERNAL=OFF

override_dh_auto_build:
	dh_auto_build
	$(MAKE) -C debian/manpages

override_dh_install:
	dh_install
	cd $(PROGDIR)/usr/share/doc/springlobby && \
	rm -fv COPYING AUTHORS
	$(RM) -r $(PROGDIR)/usr/bin

override_dh_auto_clean:
	dh_auto_clean
	$(MAKE) -C debian/manpages clean
	# Ensure we don't build against the embedded version of jsoncpp
	$(RM) -r src/downloader/lib/src/lib/jsoncpp
	$(RM) -r src/lsl/lib/jsoncpp
